# Substrate Chains .NET API Extensions
*Substrate Chains .NET API Extensions for Relay-, Para- and Solochains in the Substrate ecosystem*  

## Substrate NuGet Packages
[![GitHub issues](https://img.shields.io/github/issues/SubstrateGaming/Substrate.Chains.NET.svg)](https://github.com/SubstrateGaming/Substrate.Chains.NET/issues)
[![license](https://img.shields.io/github/license/SubstrateGaming/Substrate.Chains.NET)](https://github.com/SubstrateGaming/Substrate.Chains.NET/blob/origin/LICENSE)
[![contributors](https://img.shields.io/github/contributors/SubstrateGaming/Substrate.Chains.NET)](https://github.com/SubstrateGaming/Substrate.Chains.NET/graphs/contributors)  

### Polkadot (Relay Chain)
- Polkadot Network .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.Polkadot.NET))  
  - Substrate Polkadot .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.Polkadot.NET.Extension)](https://www.nuget.org/packages/Substrate.Polkadot.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.Polkadot.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_polkadot.yml/badge.svg)  

### Polkadot (Parachain)
- Polkadot Asset Hub .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.PolkadotAssetHub.NET))  
  - Substrate Polkadot AssetHub .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.PolkadotAssetHub.NET.Extension)](https://www.nuget.org/packages/Substrate.PolkadotAssetHub.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.PolkadotAssetHub.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_polkadotassethub.yml/badge.svg)  
- Polkadot BridgeHub .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.PolkadotBridgeHub.NET))  
  - Substrate Polkadot BridgeHub .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.PolkadotBridgeHub.NET.Extension)](https://www.nuget.org/packages/Substrate.PolkadotBridgeHub.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.PolkadotBridgeHub.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_polkadotbridgehub.yml/badge.svg) 
- Collectives .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.Collectives.NET))  
  - Substrate Collectives .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.Collectives.NET.Extension)](https://www.nuget.org/packages/Substrate.Collectives.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.Collectives.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_collectives.yml/badge.svg) 
- Ajuna Network .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.Ajuna.NET))  
  - Substrate Ajuna .NET API Extension   
[![Nuget](https://img.shields.io/nuget/v/Substrate.Ajuna.NET.Extension)](https://www.nuget.org/packages/Substrate.Ajuna.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.Ajuna.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_ajuna.yml/badge.svg)
- Astar Network .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.Astar.NET))  
  - Substrate Astar .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.Astar.NET.Extension)](https://www.nuget.org/packages/Substrate.Astar.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.Astar.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_astar.yml/badge.svg)  
- Aventus Network .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.Aventus.NET))  
  - Substrate Aventus .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.Aventus.NET.Extension)](https://www.nuget.org/packages/Substrate.Aventus.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.Aventus.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_aventus.yml/badge.svg)  
- KILT Network .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.KILT.NET))  
  - Substrate KILT .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.KILT.NET.Extension)](https://www.nuget.org/packages/Substrate.KILT.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.KILT.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_kilt.yml/badge.svg)  
- Moonbeam Network .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.Moonbeam.NET))  
  - Substrate Moonbeam .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.Moonbeam.NET.Extension)](https://www.nuget.org/packages/Substrate.Moonbeam.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.Moonbeam.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_moonbeam.yml/badge.svg)  
- Moonsama Network .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.Moonsama.NET))  
  - Substrate Moonsama .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.Moonsama.NET.Extension)](https://www.nuget.org/packages/Substrate.Moonsama.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.Moonsama.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_moonsama.yml/badge.svg)  
- Unique Network .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.Unique.NET))  
  - Substrate Unique .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.Unique.NET.Extension)](https://www.nuget.org/packages/Substrate.Unique.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.Unique.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_unique.yml/badge.svg)  
- Zeitgeist Network .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.Zeitgeist.NET))  
  - Substrate Zeitgeist .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.Zeitgeist.NET.Extension)](https://www.nuget.org/packages/Substrate.Zeitgeist.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.Zeitgeist.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_zeitgeist.yml/badge.svg)  

### Kusama (Relay Chain)
- Kusama Network .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.Kusama.NET))  
  - Substrate Kusama .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.Kusama.NET.Extension)](https://www.nuget.org/packages/Substrate.Kusama.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.Kusama.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_kusama.yml/badge.svg)  

### Kusama (Parachain)
- Kusama AssetHub .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.KusamaAssetHub.NET))  
  - Substrate Kusama AssetHub .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.KusamaAssetHub.NET.Extension)](https://www.nuget.org/packages/Substrate.KusamaAssetHub.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.KusamaAssetHub.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_kusamaassethub.yml/badge.svg)
- Kusama BridgeHub .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.KusamaBridgeHub.NET))  
  - Substrate Kusama BridgeHub .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.KusamaBridgeHub.NET.Extension)](https://www.nuget.org/packages/Substrate.KusamaBridgeHub.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.KusamaBridgeHub.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_kusamabridgehub.yml/badge.svg)
- Bajun Network .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.Bajun.NET))  
  - Substrate Bajun .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.Bajun.NET.Extension)](https://www.nuget.org/packages/Substrate.Bajun.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.Bajun.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_bajun.yml/badge.svg)  

### Other Ecosystem
- Vara Network .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.Vara.NET))  
  - Substrate Vara Network .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.Vara.NET.Extension)](https://www.nuget.org/packages/Substrate.Vara.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.Vara.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_vara.yml/badge.svg)
- Enjin Relaychain .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.Enjin.NET))  
  - Substrate Enjin Relaychain .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.Enjin.NET.Extension)](https://www.nuget.org/packages/Substrate.Enjin.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.Enjin.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_enjin.yml/badge.svg)

### Test networks
- Opal Network .NET SDK ([Link](https://github.com/SubstrateGaming/Substrate.Chains.NET/tree/main/Substrate.Opal.NET))  
  - Substrate Opal Network .NET API Extension  
[![Nuget](https://img.shields.io/nuget/v/Substrate.Opal.NET.Extension)](https://www.nuget.org/packages/Substrate.Opal.NET.Extension/)
![Nuget](https://img.shields.io/nuget/dt/Substrate.Opal.NET.Extension)  
![Build](https://github.com/SubstrateGaming/Substrate.Chains.NET/actions/workflows/publish_opal.yml/badge.svg)  

## Add or update Package

Make sure you have .NET installed ([Linux, macOS & Windows .NET Install](https://learn.microsoft.com/en-us/dotnet/core/install/))
- git clone https://github.com/SubstrateGaming/Substrate.Chains.NET.git
- create directory Substrate.<chain_name>.NET
- go into the directory
- make sure you have ```dotnet new --install Substrate.DotNet.Template``` installed
- create a new solution ```dotnet new sln```
- create the SDK 

ex. for Substrate.Statemint.NET
```
dotnet new sln
dotnet new substrate \
        --sdk_version 0.5.2 \
        --rest_service Substrate.Statemint.NET.RestService \
        --net_api Substrate.Statemint.NET.NetApiExt \
        --rest_client Substrate.Statemint.NET.RestClient \
        --metadata_websocket wss://statemint-rpc.polkadot.io \
        --force \
        --allow-scripts yes
```
Create a PR, make sure to have the following versioning for the NuGet package,   
```<Version>1.9370.0</Version>``` 1 = prod / 9370 = spec_version / 0 = iteration

## Generated by

- [Substrate .NET API](https://github.com/SubstrateGaming/Substrate.NET.API)  
  Substrate .NET API Core for substrate-based nodes

- [Substrate .NET Toolchain](https://github.com/SubstrateGaming/Substrate.NET.Toolchain)  
  Substrate .NET Toolchain model-driven SDK generator for substrate-based nodes
